#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <engine>
#include <hamsandwich>
#include <fun>
#include <zombieplague>

#define PLUGIN "[ZP] Extra Item : Sonic Knuckles"
#define VERSION "1.0.0"
#define AUTHOR "Kia"

/* Integer */

new g_iItemID

/* Boolean */

new bool:g_bHasKnuckles[33]

/* CVars */

new cvar_force, cvar_radius, cvar_damage

/* Precache */

new g_Explosion

public plugin_precache()
{
	precache_model("models/zombie_plague/p_sonicknuckles.mdl")
	precache_model("models/zombie_plague/v_sonicknuckles.mdl")
	
	precache_sound("zombie_plague/sonicknuckles.wav")
	
	g_Explosion = precache_model("sprites/shockwave.spr");
}

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	/* Registering Item */
	
	g_iItemID = zp_register_extra_item("Sonic Knuckles", 25, ZP_TEAM_HUMAN)
	
	/* Forwards */
	
	register_forward(FM_EmitSound, "func_EmitSound")
	
	/* Events */
	
	register_event("CurWeapon", "func_EventCurWeapon", "be", "1=1")
	
	/* Hamsandwich */
	
	RegisterHam(Ham_TakeDamage, "player", "func_HamTakeDamage")
	
	/* CVars */
	
	cvar_force	= register_cvar("zp_sk_force","115")
	cvar_radius	= register_cvar("zp_sk_radius","300")
	cvar_damage 	= register_cvar("zp_sk_damage","75")
}

public zp_extra_item_selected(id, ItemID)
{
	if(ItemID == g_iItemID )
	{
		g_bHasKnuckles[id] = true
		engclient_cmd(id, "weapon_knife")
	}
}

public func_EventCurWeapon(id)
{
	if(get_user_weapon(id) == CSW_KNIFE && g_bHasKnuckles[id])
	{
		entity_set_string(id, EV_SZ_viewmodel, "models/zombie_plague/v_sonicknuckles.mdl")
		entity_set_string(id, EV_SZ_weaponmodel, "models/zombie_plague/p_sonicknuckles.mdl")
	}
	return PLUGIN_CONTINUE
}

public func_HamTakeDamage(iVictim, iInflictor, iAttacker, Float:fDamage, iDamageBits )
{
	if(iInflictor == iAttacker && g_bHasKnuckles[iAttacker] && get_user_weapon(iAttacker) == CSW_KNIFE)
		func_ExecuteSonic(iAttacker)
}

public func_ExecuteSonic(id)
{
	emit_sound(id,CHAN_STATIC, "zombie_plague/sonicknuckles.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	
	new Float:iOrigin[3]
	pev(id,pev_origin,iOrigin)
	
	func_create_blast(iOrigin)
	g_bHasKnuckles[id] = false
	
	new players[32], pnum, tempid
	new Float:TempOrigin[3]
	
	new Float:iDistance, iMultiplier, iDamage
	
	new Float:vec[3];
	new Float:oldvelo[3];
	
	get_players(players, pnum, "ae", "TERRORIST")
	for(new i; i <= pnum; i++)
	{
		tempid = players[i]
		pev(tempid,pev_origin,TempOrigin)
		
		iDistance = get_distance_f(iOrigin, TempOrigin)
		
		if(iDistance < get_pcvar_num(cvar_radius) && get_user_team(id) != get_user_team(tempid) && is_user_alive(tempid))
		{
			get_user_velocity(tempid, oldvelo);
			create_velocity_vector(tempid , id , vec);
			vec[0] += oldvelo[0];
			vec[1] += oldvelo[1];
			set_user_velocity(tempid , vec)
			
			iMultiplier = get_pcvar_num(cvar_damage) * get_pcvar_num(cvar_damage) / get_pcvar_num(cvar_radius)
			iDamage = (get_pcvar_num(cvar_radius) - floatround(iDistance, floatround_floor)) * iMultiplier
			
			set_user_health(tempid, get_user_health(tempid) - iDamage)
		}
	}
}
	
// Stock by the one and only, Chronic :P
stock create_velocity_vector(victim,attacker,Float:velocity[3])
{
	if(!is_user_alive(victim) || !is_user_alive(attacker))
		return 0;

	new Float:vicorigin[3];
	new Float:attorigin[3];
	entity_get_vector(victim   , EV_VEC_origin , vicorigin);
	entity_get_vector(attacker , EV_VEC_origin , attorigin);

	new Float:origin2[3]
	origin2[0] = vicorigin[0] - attorigin[0];
	origin2[1] = vicorigin[1] - attorigin[1];

	new Float:largestnum = 0.0;

	if(floatabs(origin2[0])>largestnum) largestnum = floatabs(origin2[0]);
	if(floatabs(origin2[1])>largestnum) largestnum = floatabs(origin2[1]);

	origin2[0] /= largestnum;
	origin2[1] /= largestnum;

	velocity[0] = ( origin2[0] * (get_pcvar_float(cvar_force) * 3000) ) / get_entity_distance(victim , attacker);
	velocity[1] = ( origin2[1] * (get_pcvar_float(cvar_force) * 3000) ) / get_entity_distance(victim , attacker);
	if(velocity[0] <= 20.0 || velocity[1] <= 20.0)
	velocity[2] = random_float(200.0 , 275.0);

	return 1;
}

public func_create_blast(Float:origin[3])
{
	new temp_origin[3]
	FVecIVec(origin,temp_origin)
	
	new Float:temp_rgbF[3], temp_rgb[3]

	temp_rgbF[0] = 0.0
	temp_rgbF[1] = 206.0
	temp_rgbF[2] = 209.0

	FVecIVec(temp_rgbF,temp_rgb)

	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_BEAMCYLINDER)
	write_coord(temp_origin[0])
	write_coord(temp_origin[1])
	write_coord(temp_origin[2])
	write_coord(temp_origin[0])
	write_coord(temp_origin[1])
	write_coord(temp_origin[2] + 385)
	write_short(g_Explosion)
	write_byte(0)
	write_byte(0)
	write_byte(4)
	write_byte(60)
	write_byte(0)
	write_byte(temp_rgb[0])
	write_byte(temp_rgb[1])
	write_byte(temp_rgb[2])
	write_byte(100)
	write_byte(0)
	message_end()

	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_BEAMCYLINDER)
	write_coord(temp_origin[0])
	write_coord(temp_origin[1])
	write_coord(temp_origin[2])
	write_coord(temp_origin[0])
	write_coord(temp_origin[1])
	write_coord(temp_origin[2] + 470)
	write_short(g_Explosion)
	write_byte(0)
	write_byte(0)
	write_byte(4)
	write_byte(60)
	write_byte(0)
	write_byte(temp_rgb[0])
	write_byte(temp_rgb[1])
	write_byte(temp_rgb[2])
	write_byte(100)
	write_byte(0)
	message_end()

	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_BEAMCYLINDER)
	write_coord(temp_origin[0])
	write_coord(temp_origin[1])
	write_coord(temp_origin[2])
	write_coord(temp_origin[0])
	write_coord(temp_origin[1])
	write_coord(temp_origin[2] + 555)
	write_short(g_Explosion)
	write_byte(0)
	write_byte(0)
	write_byte(4)
	write_byte(60)
	write_byte(0)
	write_byte(temp_rgb[0])
	write_byte(temp_rgb[1])
	write_byte(temp_rgb[2])
	write_byte(100)
	write_byte(0)
	message_end()

	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_DLIGHT)
	write_coord(temp_origin[0])
	write_coord(temp_origin[1])
	write_coord(temp_origin[2])
	write_byte(floatround(200/5.0))
	write_byte(temp_rgb[0])
	write_byte(temp_rgb[1])
	write_byte(temp_rgb[2])
	write_byte(8)
	write_byte(60)
	message_end()
}
